/* Ok. I use lists, which is useless. I could just dump functions
 * on the fly. Don't remember why I began with lists... Anyway, it
 * works, so it's fine.
 */

#include <stdio.h>
#include <stdlib.h>

#include "list.h"

/* number of functions that will be defined */
#define N 50000
/* number of calls per function */
#define NB_CALLS 100

#define D(x) fprintf(stdout, "%s", x)

struct {
  int loop;	/* not used in fact, I could remove it */
  int called;
  list calls;
} funs[N];

void dump_loop(int n)
{
  char f[512];

  sprintf(f, "{int i;for(i=0;i<%d;i++){float a,b;a=i+1;b=i+2;a=a*b;}}\n", n);
  D(f);
}

void dump_calls(list *l)
{
  int i;
  int n = list_size(l);
  char f[512];
  for (i=0; i<n; i++) {
    sprintf(f, "  if (nb_calls < max_calls) { nb_calls++; f%d(); }\n", list_get(l, i));
    D(f);
  }
}

void dump(void)
{
  int i;
  char f[512];

  D("#include <stdio.h>\n");
  D("unsigned int nb_calls;\nunsigned long max_calls=1000;");

  for (i=1; i<N; i++) {
    sprintf(f, "void f%d(void);\n", i);
    D(f);
  }

  for (i=0; i<N; i++) {
    if (!i) {
      D("#include <stdlib.h>\n");
      D("int main(int n, char **v)\n{\n");
      D("  if (n==2) max_calls=atol(v[1]);\n");
    } else {
      sprintf(f, "void f%d(void)\n{\n", i);
      D(f);
    }
    dump_loop(funs[i].loop);
    dump_calls(&funs[i].calls);
    if (!i) {
      D("  printf(\"%u calls\\n\", nb_calls);\n");
      D("  return 0;\n");
    }
    D("}\n");
  }
}

void add_call(int caller, int called)
{
  if (called <= 0) { fprintf(stderr, "called %d too low\n", called); return; }
  if (called >= N) { fprintf(stderr, "called %d too big\n", called); return; }
  if (list_add(&funs[caller].calls, called) == -1) {
    fprintf(stderr, "err\n");
    exit(1);
  }
  funs[called].called++;
}

int rdom(int min, int max)
{
  return min + (int) ((max-min+1) * (rand() / (RAND_MAX + 1.0)));
}

void generate(int n)
{
  int nb_calls = rdom(0, NB_CALLS);
  int i;

  for (i=0; i<nb_calls; i++) {
    if (n != N-1) add_call(n, rdom(n+1, N-1));
  }

  funs[n].loop = 0; /*rdom(100, 1000);*/
}

int main(void)
{
  int i;
  for (i = 0; i < N; i++) generate(i);
  for (i=1; i<N; i++) if (funs[i].called==0) add_call(0, i);
  dump();
  return 0;
}
